import _objectSpread from "@babel/runtime/helpers/esm/objectSpread";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import React, { useState } from 'react';
import PropTypes from 'prop-types';
import { ToggleSwitchTypeRender } from './SwitchType/toggle';
import { SingleSwitchTypeRender } from './SwitchType/single';
import { SIZES, TYPES, SUPPORTED_KEYS } from './config';

var AtomSwitch = function AtomSwitch(props) {
  var initialValue = props.initialValue,
      disabled = props.disabled,
      onToggleCallback = props.onToggle,
      value = props.value,
      type = props.type;

  var _useState = useState(initialValue),
      _useState2 = _slicedToArray(_useState, 2),
      isToggle = _useState2[0],
      setIsToggle = _useState2[1];

  var _useState3 = useState(false),
      _useState4 = _slicedToArray(_useState3, 2),
      isFocus = _useState4[0],
      setIsFocus = _useState4[1];

  var _useState5 = useState(false),
      _useState6 = _slicedToArray(_useState5, 2),
      isClick = _useState6[0],
      setIsClick = _useState6[1];

  var onBlur = function onBlur() {
    setIsFocus(false);
    setIsClick(false);
  };

  var onFocus = function onFocus() {
    setTimeout(function () {
      setIsFocus(true);
    }, 150);
  };

  var onClick = function onClick() {
    setIsClick(true);
  };

  var onToggle = function onToggle(forceValue) {
    if (disabled === true) return;

    if (value !== undefined) {
      return onToggle(!value);
    }

    var newIsToggle = forceValue !== undefined ? forceValue : !isToggle;
    setIsToggle(newIsToggle);
    onToggleCallback(newIsToggle);
  };

  var onKeyDown = function onKeyDown(ev) {
    if (disabled === true) return;

    if (SUPPORTED_KEYS.includes(ev.key)) {
      onToggleCallback();
      ev.preventDefault();
    }
  };

  var commonProps = _objectSpread({}, props, {
    isFocus: isFocus,
    isClick: isClick,
    isToggle: isToggle,
    onBlur: onBlur,
    onClick: onClick,
    onFocus: onFocus,
    onKeyDown: onKeyDown,
    onToggle: onToggle
  });

  return type === TYPES.SINGLE ? React.createElement(SingleSwitchTypeRender, commonProps) : React.createElement(ToggleSwitchTypeRender, commonProps);
};

AtomSwitch.displayName = 'AtomSwitch';
AtomSwitch.defaultProps = {
  disabled: false,
  initialValue: false,
  labelLeft: 'Off',
  labelRight: 'On',
  size: SIZES.DEFAULT,
  type: TYPES.TOGGLE
};
export default AtomSwitch;